# coding: utf-8

"""
    EPM REST API

    REST API description of the ElasTest Platform Manager Module.

    OpenAPI spec version: 0.1.2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import epm_client
from epm_client.rest import ApiException
from epm_client.apis.resource_group_api import ResourceGroupApi
from epm_client.models import ResourceGroup, VDU, PoP, Network


class TestResourceGroupApi(unittest.TestCase):
    """ ResourceGroupApi unit test stubs """

    def setUp(self):
        self.api = epm_client.apis.resource_group_api.ResourceGroupApi()

    def tearDown(self):
        pass

    @unittest.skip
    def test_create_resource_group(self):
        """
        Test case for create_resource_group

        Creates a new Resource Group.
        """
        pops = list()
        networks = list()
        vdus = list()
        pop = PoP(interface_endpoint="unix:///var/run/docker.sock", name="test")
        network = Network(name="test-network", po_p_name="test")
        vdu = VDU(name="test-vdu", image_name="services/rabbitmq", net_name="test-network", po_p_name="test")
        pops.append(pop)
        networks.append(network)
        vdus.append(vdu)
        resourceGroup = ResourceGroup(name="test-resourcegroup", pops=pops, networks=networks, vdus=vdus)
        self.api.create_resource_group(resourceGroup.to_dict())
        pass

    @unittest.skip
    def test_delete_resource_group(self):
        """
        Test case for delete_resource_group

        Deletes a Resource Group.
        """
        self.api.delete_resource_group("7133fe79-cbb0-45aa-a078-0a4bb067c2fc")
        pass

    @unittest.skip
    def test_get_all_resource_groups(self):
        """
        Test case for get_all_resource_groups

        Returns all Resource Groups.
        """
        self.api.get_all_resource_groups()
        pass

    @unittest.skip
    def test_get_resource_group_by_id(self):
        """
        Test case for get_resource_group_by_id

        Returns a Resource Group.
        """
        self.api.get_resource_group_by_id("cf87eb7e-1550-4404-a8e3-084e66500912")
        pass

    @unittest.skip
    def test_update_resource_group(self):
        """
        Test case for update_resource_group

        Updates a ResourceGroup.
        """
        pass


if __name__ == '__main__':
    unittest.main()
