# coding: utf-8

"""
    EPM REST API

    REST API description of the ElasTest Platform Manager Module.

    OpenAPI spec version: 0.1.2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import epm_client
from epm_client.rest import ApiException
from epm_client.apis.runtime_api import RuntimeApi
from epm_client.models import FileUploadBody, FileDownloadBody, CommandExecutionBody


class TestRuntimeApi(unittest.TestCase):
    """ RuntimeApi unit test stubs """

    def setUp(self):
        self.api = epm_client.apis.runtime_api.RuntimeApi()

    def tearDown(self):
        pass

    @unittest.skip
    def test_download_file_from_instance(self):
        """
        Test case for download_file_from_instance

        Downloads a file from a VDU.
        """
        file_download_body = FileDownloadBody(path="/tmp/Example.txt")
        self.api.download_file_from_instance(id="53879a7c-6cf7-4f68-891c-9f8607e5a2a9", file_download_body=file_download_body.to_dict())
        pass

    @unittest.skip
    def test_execute_on_instance(self):
        """
        Test case for execute_on_instance

        Executes given command on the given VDU.
        """
        command_exec_body = CommandExecutionBody(command="ls /tmp/", await_completion="true")
        self.api.execute_on_instance(id="df99cba1-e234-41c6-baf7-b03cfa576107", command_execution_body=command_exec_body.to_dict())
        pass

    @unittest.skip
    def test_start_instance(self):
        """
        Test case for start_instance

        Starts the given VDU.
        """
        self.api.start_instance("df99cba1-e234-41c6-baf7-b03cfa576107")
        pass

    @unittest.skip
    def test_stop_instance(self):
        """
        Test case for stop_instance

        Stops the given VDU.
        """
        self.api.stop_instance("df99cba1-e234-41c6-baf7-b03cfa576107")
        pass

    @unittest.skip
    def test_upload_file_to_instance_by_file(self):
        """
        Test case for upload_file_to_instance_by_file

        Uploads a file to a VDU.
        """
        id = "82ae4ce1-4e18-4547-beb0-c0309af4b5a9"
        remote_path = "/tmp/"
        self.api.upload_file_to_instance_by_file(id=id, remote_path=remote_path, file="/net/u/rvl/Downloads/Example.txt")
        pass

    @unittest.skip
    def test_upload_file_to_instance_by_path(self):
        """
        Test case for upload_file_to_instance_by_path

        Uploads a file to a VDU.
        """
        id = "82ae4ce1-4e18-4547-beb0-c0309af4b5a9"
        remote_path = "/tmp/"
        host_path = "/net/u/rvl/Downloads/Example2.txt"
        file_upload_body = FileUploadBody(remote_path=remote_path, host_path=host_path)
        self.api.upload_file_to_instance_by_path(id=id, file_upload_body=file_upload_body.to_dict())
        pass


if __name__ == '__main__':
    unittest.main()
